; this was copied verbatim from the bsxn disassembly, then unnecessary portions were chopped out
; this is the mode $5 / $10 handler
;
; the flash algorithm can be added to this


.code
.org	0xFF8100


	        link    a6,#-8         
                movem.l d0-d2/d5/a0,-(sp)
		move.w	#0x20,(0xffc006).w	; disable IOD COP
		move.w	#0x7020,(0xfffa4e).w	; enable 16 bit write to flash
		move.b	#4,(0xfffa21).w		; disable software watchdog
		lea.l	-8(a6),a0
		move.w	#0x10AA,(a0)		;
		moveq	#2,d0			; msg length
		bsr.w	sub_EE12		; go transmit mode 6 okay

start:          move.w  (0xFFFFFC0A).w,d0 	; SCCR1
                andi.w  #0xff0f,d0        	; $FF0F - DISABLE SCI INTERRUPTS
                move.w  d0,(0xFFFFFC0A).w 	; SCCR1
                bclr    #3,(0xFFFFFC0B).w 	; SCCR1 - DISABLE TRANSMIT
                clr.b   d0              	; CLEAR
                bclr    #1,(0xFFFFC002).w 	; SWITCH TO RECEIVE - PORTB
                move.w  (0xFFFFFC0A).w,d5 	; SCCR1
                ori.w   #6,d5           	; 0x06 : ENABLE RECEIVE, WAKEUP RECEIVER
                move.w  d5,(0xFFFFFC0A).w 	; SCCR1
                clr.b   (0xFFFF8FD1).w 		; CLEAR SCI CKSUM
                move.l  d0,d5			; CLEAR d5
                bsr.w   sub_EDAA        	; GO GET DATA FROM SCDR - RETURN WITH 1ST DATA BYTE IN d0
                move.b  d0,d1           	; MOVE DATA INTO d1
                move.b  d1,(0xFFFF8FD0).w 	; SAVE DATA
                bsr.w   sub_16E0    		; GET FFFF8FC2 -> d0
                move.l  d0,(0xFFFF8FD2).w 	; SAVE FFFF8FC2
loc_EF22:       bsr.w   sub_EDAA        	; GO GET DATA FROM SCDR - RETURN WITH 2ND DATA BYTE IN d0
                subi.b  #0x55,d0 ; 'U'   	; SUBTRACT OFFSET
                move.b  d0,d2           	; MOVE MSG LENGTH TO d2
                cmpi.b  #-0x56,d2        	; $AA ??
                bls.s   loc_EF3A        	; BRANCH IF <= $AA, ELSE
                bsr.w   stp     		; STOP

loc_EF3A:       bsr.w   sub_EDAA        	; GO GET DATA FROM SCDR - RETURN WITH 3RD DATA BYTE IN d0
                cmpi.b  #5,d0           	; MODE 5 ??
                bne.s   loc_EF8E        	; BRANCH IF NOT 5, ELSE
                bsr.w   sub_EDAA        	; GO GET DATA FROM SCDR - RETURN WITH DATA IN d0
                tst.b   (0xFFFF8FD1).w 		; TEST RUNNING CKSUM
                beq.s   loc_EF7C        	; BRANCH IF Z, ELSE
                nop		     		; STOP
		nop

loc_EF7C:       moveq   #2,d0           	; MSG LENGTH = 2
                move.w   #0x05aa,(a0)       	; 
                bsr.w   sub_EE12        	; GO TRANSMIT
                bra.w   loc_F016        	; RETURN

loc_EF8E:       cmpi.b  #0x10,d0         	; MODE $10 ??
                bne.s   loc_F010        	; BRANCH IF NOT $10 (STOP), ELSE
                bsr.w     sub_EDAA        	; GO GET DATA FROM SCDR - RETURN WITH DATA IN d0
                move.b  d0,d5
                bsr.w     sub_EDAA        	; GO GET DATA FROM SCDR - RETURN WITH DATA IN d0
                move.b  d0,d1
                bsr.w     sub_EDAA        	; GO GET DATA FROM SCDR - RETURN WITH DATA IN d0
                andi.l  #0xFF,d1         	; CLEAR EVERYTHING EXCEPT LOW BYTE
                asl.w   #8,d1           	; SHIFT TO MID LOW BYTE
                andi.l  #0xFFFF,d1       	; CLEAR UPPER WORD
                andi.l  #0xFF,d5         	; CLEAR EVERYTHING EXCEPT LOW BYTE
                asl.l   #8,d5           	; SHIFT TO MID UPPER BYTE
                asl.l   #8,d5
                add.l   d1,d5           	; ADD THEM TOGETHER
                andi.l  #0xFF,d0         	; CLEAR EVERYTHING EXCEPT LOW BYTE
                add.l   d0,d5           	; ADD TOGETHER
                move.l  d5,-8(a6)    		; SAVE ADDRESS
                move.l  d5,-4(a6)    		; SAVE ADDRESS
                moveq   #5,d1           	; d1 = 5
                cmpi.b  #5,d2           	; MSG LENGTH = 5 ??
                bra.s   loc_EFF4

loc_EFDC:       bsr.w     sub_EDAA        	; GO GET DATA FROM SCDR - RETURN WITH DATA IN d0
                movea.l -4(a6),a0    		; INDEX
                move.b  d0,(a0)         	; SAVE DATA
                addq.l  #1,a0           	; ADD TO INDEX
                move.l  a0,-4(a6)    		; SAVE INDEX
                addq.b  #1,d1           	; INCREMENT RUNNING MSG LENGTH
                bcs.s   loc_EFF6        	; BRANCH IF OVERFLOW, ELSE
                cmp.b   d1,d2           	; COMPARE MSG LENGTH

loc_EFF4:       bcc.s   loc_EFDC        	; BRANCH IF <= MSG LENGTH (LOOP TILL DONE), ELSE
loc_EFF6:       bsr.w     sub_EDAA        	; GET CKSUM
                tst.b   (0xFFFF8FD1).w 		; SCI RUNNING CKSUM
		nop
		nop


loc_F008:       movea.l -8(a6),a0    		; GET SUBROUTINE ADDRESS
                jsr     (a0)            	; DO REQUESTED SUBROUTINE
                bra.s   loc_F016        	; RETURN

loc_F010:       bsr.w   stp	    		; STOP
loc_F016:       bra.w   start			;BRANCH BACK AND START AGAIN
       		movem.l (sp)+,d0-d2/d5/a0
                unlk    a6

;----------------
; TRANSMIT 
;----------------
sub_EE12:       movem.l d1-d2/a1,-(sp)
                move.b  d0,d2           	; MOVE MSG LENGTH TO d2
                move.w  (0xFFFFFC0A).w,d0	; SCCR1
                andi.w  #-0xF1,d0
                move.w  d0,(0xFFFFFC0A).w 	; SCCR1
                move.w  (0xFFFFFC0A).w,d0 	; SCCR1
                andi.w  #-7,d0
                move.w  d0,(0xFFFFFC0A).w 	; SCCR1
                bset    #3,(0xFFFFFC0B).w 	; SCCR1 - ENABLE TRANSMIT
                bset    #1,(0xFFFFC002).w 	; ENABLE TRANSMIT - PORTB
                clr.b   (0xFFFF8FD1).w 		; CLEAR SCI RUNNING CKSUM
                move.b  (0xFFFF8FD0).w,d0 	; WR 1ST MSG BYTE (SHOULD BE DEVICE ID)
                bsr.w     sub_EDF4        	; GO WR d0 TO SCDR
		move.l  d2,d0           	; MOVE MSG LENGTH TO d0
                addi.b  #0x55,d0 ; 'U'   	; ADD OFFSET
                bsr.w     sub_EDF4        	; GO WR d0 TO SCDR
                moveq   #1,d1
                cmpi.b  #1,d2           	; 2ND LAST BYTE TO TRANSMIT ??
                bra.s   loc_EE7A

loc_EE6A:       move.b  (a0),d0         	; GET NEXT BYTE TO TRANSMIT
                bsr.w     sub_EDF4        	; GO WR d0 TO SCDR
                addq.l  #1,a0           	; INCREMENT INDEX
                addq.b  #1,d1           	; INCREMENT RUNNING MSG LENGTH
                bcs.s   loc_EE7C        	; BRANCH IF OVERFLOW, ELSE
                cmp.b   d1,d2           	; COMPARE MSG LENGTH
loc_EE7A:       bcc.s   loc_EE6A        	; LOOP TILL DONE
loc_EE7C:       move.b  (0xFFFF8FD1).w,d0 	; GET SCI CKUSM
                bsr.w     sub_EDF4        	; GO WR d0 TO SCDR

loc_EE86:       btst    #7,(0xFFFFFC0D).w 	; SCSR - TRANSMIT COMPLETE ??
                beq.s   loc_EE86        	; WAIT TILL TRANSMIT COMPLETE
                bclr    #3,(0xFFFFFC0B).w 	; SCCR1
                bclr    #1,(0xFFFFC002).w 	; DISABLE TRANSMIT - PORTB
                movem.l (sp)+,d1-d2/a1
                rts     

;----------------
; WR d0 TO SCDR
;----------------
sub_EDF4:       move.l  d1,-(sp)
loc_EDF6:       bsr.w     RESETCOP   		; RESET COP
                btst    #0,(0xFFFFFC0C).w 	; SCSR - TDRE ??
                beq.s   loc_EDF6        	; LOOP UNTIL TDRE
                move.b  d0,d1
                move.b  d1,(0xFFFFFC0F).w 	; WR d1 TO SCDR
                sub.b   d1,(0xFFFF8FD1).w 	; SUBTRACT FROM RUNNING CKSUM
                move.l  (sp)+,d1
                rts

;------------------     
; RECEIVE ROUTINE
;------------------
sub_EDAA:       move.l  d1,-(sp)
loc_EDAC:       bsr.w     sub_16E0    		; GET FFFF8FC2 -> d0
                sub.l   (0xFFFF8FD2).w,d0 	; SUBTRACT PREVIOUS TIME
                cmpi.l  #0xa0000,d0      	; ? 2 seconds
                bcs.s   loc_EDC6        	; BRANCH IF < CAL, ELSE
                bsr.w   stp     		; STOP
                bra.s   loc_EDCC

loc_EDC6:       bsr.w     RESETCOP    		; GO RESET COP
loc_EDCC:       btst    #6,(0xFFFFFC0D).w 	; SCSR - RDRF ??
                beq.s   loc_EDAC        	; WAIT TILL RDRF
                move.w  (0xFFFFFC0C).w,d0 	; SCSR
                andi.w  #0x0E,d0          	; ERRORS ??
                sne     d0
                neg.b   d0
                move.b  (0xFFFFFC0F).w,d1 	; SCDR LSB
                tst.b   d0
                bne.s   loc_EDAC        	; BRANCH IF ERRORS, ELSE
                move.b  (0xFFFFFC0F).w,d0 	; SCDR LSB
                add.b   d0,(0xFFFF8FD1).w 	; ADD TO RUNNING CKSUM
                move.l  (sp)+,d1
                rts     

;-----------------------
RESETCOP:	move.b 	#0x55,0xFFFA27.w
		move.b 	#0xAA,0xFFFA27.w
		bclr	#7,0xFFC006.w
		bset	#7,0xFFC006.w
		rts

;-----------------------
stp:		stop	#0x2700			;


;
; routine to check the time
;
sub_16E0        move    sr,-(sp)
                ori     #0x700,sr        	; HOLD INTERRUPTS
                move.w  (0xFFFFE1EE).w,d0 	; FREE RUNNING COUNTER
                move.w  d0,(0xFFFF8FC2+2).w 	; SAVE IN FFFF8FC4
                cmp.w   (0xFFFF8FCA).w,d0 	; COMPARE PREVIOUS
                bcc.s   loc_16F8        	; BRANCH IF >= PREV, ELSE
                addq.w  #1,(0xFFFF8FC2).w 	; ADD 1
 
loc_16F8:       move.w  d0,(0xFFFF8FCA).w 	; SAVE FOR NEXT PASS
                move.l  (0xFFFF8FC2).w,d0
                move    (sp)+,sr        	; RESTORE INTERRUPTS
                rts     



;
; get flash identifier
; to confirm flash chip size
;
		movea.l	#0x0,a1			;
		move.w	#0x50,(a1)		; clear flash reg
		move.w	#0x90,(a1)		; get flash identifier
		movea.l	#0,a0			; 
		moveq	#4,d0			; msg length
		bsr.w	sub_EE12		; 
		move.w	#0xff,(a1)		; reset flash so that it will work if the whole thing crashes
		move.w	#0xff,(a1)		;
		rts				;


;
; erase algorithm
; a1 points to the flash status reg
; a2 points to the memory block to be erased
; a0 is used to read the flash status reg
;
		movea.l	(0xff8008).w,a2		; get address of block to erase
		move.w	#0x20,(a2)		; erase 1st block
		move.w	#0xd0,(a2)		; confirm erase 1st block
		movea.l	#0,a0			; index flash status reg
		move.w	#0x50,(a0)		; clear flash reg
L1:		bsr.w	RESETCOP
		move.w	#0x70,(a0)		; read flash reg
		clr.l	d4			;
		move.w	(a0),d4			; wait for erase confirmed
		andi.w	#0x80,d4		; 
		beq.s	L1			; 
		moveq	#2,d0			;
		bsr.w	sub_EE12		; go transmit flash status
		rts

;
; flash algorithm
; each block of data will be loaded into ram starting at 0xff8000 (0x80 sized blocks)
; the start of data address will be held in 0xff8008 (dword)
; the length will be held in 0xff800c (word)
; data will start at 0xff800e
; msg structure:  $f4,msg length,$10,$ff,$80,$00,jsr start,address,length,cksum
;
; a2 points to the address to be programmed
; a1 points to the data held in ram
; a0 points to the flash status reg
;
		move.w	(0xff800c).w,d3		; number of bytes to program
		movea.l	#0xff800e,a1		; index the data to be programmed
		movea.l	(0xff8008).w,a2		; get rom section start address
		movea.l	#0,a0			; index flash status reg
L3:		bsr.w	RESETCOP		;
		move.w	#0x40,(a2)		; program command
		move.w	(a1),(a2)		; 
		move.w	#0x50,(a0)		; clear the flash status reg
L4:		move.w	#0x70,(a0)		; read flash status reg
		move.w	(a0),d4			; wait for program confirmed
		andi.w	#0x80,d4		; 
		beq.s	L4			;
		addq.l	#2,a1
		addq.l	#2,a2 
		subq.w	#2,d3
		bne.s	L3			; loop till done
		moveq	#2,d0			; 
		bsr.w	sub_EE12		; go transmit contents of flash status reg
		rts

;
; this is for reseting the pcm after programming
; *******  this works!!  **********
;
finish:		movea.l	#0,a0
		move.w	#0xff,(a0)		; reset flash
		move.w	#0xff,(a0)		; reset flash
		move.w	#0x80,(0xffc006).w	; enable IOD COP
		move.w	#0x7020,(0xfffa4e).w	; enable 16 bit write to flash
		move.b	#0x24,(0xfffa21).w	; enable software watchdog and bus monitor
		stop	#0x2700			; allow interrupts
